//+------------------------------------------------------------------+
//|                                                      Volumes.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"
//---- indicator settings
#property indicator_separate_window
#property indicator_minimum 0
#property indicator_buffers 2
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern string TimeFrame = "Current time frame";

//
//
//
//
//

double ExtVolumesBuffer[];
double ExtVolumesUpBuffer[];
double ExtVolumesDnBuffer[];
double trend[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,ExtVolumesUpBuffer); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtVolumesDnBuffer); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ExtVolumesBuffer);   SetIndexLabel(2,"Volumes");
   SetIndexBuffer(3,trend);
   
   //
   //
   //
   //
   //
   
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+" Volumes");
return(0);
}
  
//+------------------------------------------------------------------+
//| Volumes                                                          |
//+------------------------------------------------------------------+
//
//

int start()
  {
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ExtVolumesUpBuffer[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
     for(i=limit; i>=0; i--)
     {
        ExtVolumesUpBuffer[i] = EMPTY_VALUE;
        ExtVolumesDnBuffer[i] = EMPTY_VALUE;
        trend[i] = trend[i+1];
             
        ExtVolumesBuffer[i]  = Volume[i];
        if (ExtVolumesBuffer[i]>ExtVolumesBuffer[i+1]) trend[i] = 1; 
        if (ExtVolumesBuffer[i]<ExtVolumesBuffer[i+1]) trend[i] =-1; 
        if (trend[i] == 1) ExtVolumesUpBuffer[i] = ExtVolumesBuffer[i];    
        if (trend[i] ==-1) ExtVolumesDnBuffer[i] = ExtVolumesBuffer[i];        
     }        
   return(0);
  }
  
  //
  //
  //
  //
  //
  
  limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
  for (i=limit;i>=0; i--)
  {
     int y = iBarShift(NULL,timeFrame,Time[i]);
        ExtVolumesBuffer[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",2,y);
        trend[i]              = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",3,y);
        ExtVolumesUpBuffer[i] = EMPTY_VALUE;
        ExtVolumesDnBuffer[i] = EMPTY_VALUE;
        if (trend[i] == 1) ExtVolumesUpBuffer[i] = ExtVolumesBuffer[i];    
        if (trend[i] ==-1) ExtVolumesDnBuffer[i] = ExtVolumesBuffer[i];    
   } 
return(0);         
} 

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
return(s);
}

